#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Odds2_DayBuff.h"
std::auto_ptr<Odds2_DayBuff> Odds2_DayBuff::msSingleton(nullptr);

int Odds2_DayBuff::GetCount()
{
	return (int)mMapData.size();
}

const Odds2_DayBuffData* Odds2_DayBuff::GetData(int BuffID)
{
	auto it = mMapData.find(BuffID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Odds2_DayBuffData>& Odds2_DayBuff::GetMapData()
{
	return mMapData;
}

void Odds2_DayBuff::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Odds2_DayBuff.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Odds2_DayBuffData data;
		data.mBuffID = element->IntAttribute("BuffID");
		data.mDay = element->IntAttribute("Day");
		data.mBuffEffectMin = element->IntAttribute("BuffEffectMin");
		data.mBuffEffectMax = element->IntAttribute("BuffEffectMax");
		if (mMapData.find(data.mBuffID) != mMapData.end())std::cout <<"data refind:" << data.mBuffID << std::endl;
		CCASSERT(mMapData.find(data.mBuffID) == mMapData.end(), "data.mBuffID is exists");
		mMapData.insert(std::make_pair(data.mBuffID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Odds2_DayBuff Loaded. Load Data:%u", mMapData.size());
}

void Odds2_DayBuff::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Odds2_DayBuff");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Odds2_DayBuff");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Odds2_DayBuffData data;
		LuaCfgHelper::readInt(L, "BuffID", data.mBuffID);
		LuaCfgHelper::readInt(L, "Day", data.mDay);
		LuaCfgHelper::readInt(L, "BuffEffectMin", data.mBuffEffectMin);
		LuaCfgHelper::readInt(L, "BuffEffectMax", data.mBuffEffectMax);
		if (mMapData.find(data.mBuffID) != mMapData.end())std::cout <<"data refind:" << data.mBuffID << std::endl;
		CCASSERT(mMapData.find(data.mBuffID) == mMapData.end(), "data.mBuffID is exists");
		mMapData.insert(std::make_pair(data.mBuffID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Odds2_DayBuff Loaded. Load Data:%u", mMapData.size());
}

void Odds2_DayBuff::Reload()
{
	mMapData.clear();
	Load();
}

Odds2_DayBuff* Odds2_DayBuff::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Odds2_DayBuff());
	}
	return msSingleton.get();
}

void Odds2_DayBuff::Release()
{
	msSingleton.reset(nullptr);
}
